"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeschichteWithHistory = exports.handleHistoryEvent = void 0;
const react_1 = __importStar(require("react"));
const shallow_1 = require("zustand/shallow");
const store_js_1 = require("../../store.js");
const utils_js_1 = require("../../utils.js");
const handleHistoryV4 = (update, action) => {
    return {
        action,
        location: update,
    };
};
const handleHistoryV5 = ({ location, action, }) => {
    return {
        action,
        location,
    };
};
let handler;
const handleHistoryEvent = (action) => {
    if (handler) {
        return handler;
    }
    if (action) {
        return (handler = handleHistoryV4);
    }
    return (handler = handleHistoryV5);
};
exports.handleHistoryEvent = handleHistoryEvent;
exports.GeschichteWithHistory = (0, react_1.forwardRef)(({ children, history }, ref) => {
    const historyInstance = (0, react_1.useMemo)(() => {
        return {
            initialSearch: () => history.location.search,
            push: async (query) => {
                history.push({
                    hash: history.location.hash,
                    search: (0, utils_js_1.createSearch)(query),
                }, { __g__: true });
            },
            replace: async (query) => history.replace({
                hash: history.location.hash,
                search: (0, utils_js_1.createSearch)(query),
            }, { __g__: true }),
        };
    }, [history]);
    const value = (0, react_1.useMemo)(() => (0, store_js_1.createGeschichte)(historyInstance), [historyInstance]);
    const state = value(({ unregister, updateFromQuery, }) => ({
        unregister,
        updateFromQuery,
    }), shallow_1.shallow);
    (0, react_1.useEffect)(() => {
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        return history.listen((update, maybeAction) => {
            const { location, action } = (0, exports.handleHistoryEvent)(maybeAction)(update, maybeAction);
            // don't handle our own actions
            if ((action === 'REPLACE' || action === 'PUSH') &&
                location.state &&
                // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                // @ts-ignore
                location.state.__g__) {
                return;
            }
            state.updateFromQuery(location.search);
        });
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [history, state.updateFromQuery]);
    (0, react_1.useImperativeHandle)(ref, () => ({
        updateFromQuery: state.updateFromQuery,
    }), [state]);
    (0, react_1.useEffect)(() => {
        const { unregister } = state;
        return () => {
            return unregister();
        };
    }, [state]);
    return (react_1.default.createElement(store_js_1.StoreContext.Provider, { value: value }, children));
});
exports.default = exports.GeschichteWithHistory;
